import { Cookies, Notify } from "quasar";

import {
  createRouter,
  createMemoryHistory,
  createWebHistory,
  createWebHashHistory,
} from "vue-router";

import { permissionStore } from "src/stores/permission";
import { route } from "quasar/wrappers";
import { useI18n } from "vue-i18n";

import routes from "./routes";

/*
 * If not building with SSR mode, you can
 * directly export the Router instantiation;
 *
 * The function below can be async too; either use
 * async/await or return a Promise which resolves
 * with the Router instance.
 */

export default route(function (/* { store, ssrContext } */) {
  const createHistory = process.env.SERVER
    ? createMemoryHistory
    : process.env.VUE_ROUTER_MODE === "history"
      ? createWebHistory
      : createWebHashHistory;

  const Router = createRouter({
    scrollBehavior: () => ({ left: 0, top: 0 }),
    routes,

    // Leave this as is and make changes in quasar.conf.js instead!
    // quasar.conf.js -> build -> vueRouterMode
    // quasar.conf.js -> build -> publicPath
    history: createHistory(process.env.VUE_ROUTER_BASE),
  });

  Router.beforeEach(async (to, from, next) => {
    const { getAccess } = permissionStore();

    const access_token = Cookies.get("access_token");

    if (to.meta.requireAuth && !access_token) {
      return next({ name: "LoginPage" });
    }

    if (access_token) {
      if (to.name == "LoginPage") {
        return next({ name: "DashboardPage" });
      }
    }

    if (to.meta.requiredPermission) {
      const permission = getAccess(to.meta.requiredPermission, "view");

      if (!permission) {
        Notify.create({
          message: useI18n().t("validation.permissions.view"),
          type: "negative",
        });

        return next(from);
      }
    }

    return next();
  });

  return Router;
});
